#include "ChannelWorker.h"
#include <osg/Notify>


ChannelWorker::ChannelWorker(int numThreads, OpenThreads::Barrier& syncBarrier)
 : _numThreads(numThreads), _syncBarrier(syncBarrier), _done(false)
{
	OSG_ALWAYS<<"ChannelWorker instantiated."<<std::endl;
}

ChannelWorker::~ChannelWorker()
{
	cancel();
}

void ChannelWorker::run()
{
	OSG_ALWAYS<<"ID "<<getThreadId()<<" running!"<<std::endl;

	// Do the work
	int i=0;
	do
	{
		OSG_ALWAYS<<"ID "<<getThreadId()<<" :: itr "<<i++<<std::endl;

		for(int i=0;i<100;i++)
		OSG_ALWAYS<<"";

	} while (!testCancel() && !_done);	// repeat as long it is canceld or set as Done


	//_syncBarrier.block(_numThreads);  // Sync the threads.

}

void ChannelWorker::setDone(bool done)
{
	_done = done;
}

int ChannelWorker::cancel()
{
    OSG_ALWAYS<<"Cancelling ChannelWorker "<<this<<" isRunning()="<<isRunning()<<std::endl;

    if( isRunning() )
    {
        _done = true;

        OSG_ALWAYS<<"   Doing cancel "<<this<<std::endl;

        // then wait for the the thread to stop running.
        while(isRunning())
        {
            // commenting out debug info as it was cashing crash on exit, presumable
            // due to OSG_NOTIFY or std::cout destructing earlier than this destructor.
            OSG_ALWAYS<<"   Waiting for ChannelWorker to cancel "<<this<<std::endl;
            OpenThreads::Thread::YieldCurrentThread();
        }
    }

    OSG_ALWAYS<<"  ChannelWorker::cancel() thread cancelled "<<this<<" isRunning()="<<isRunning()<<std::endl;

    return 0;
}