#pragma once

#include <osg/Referenced>
#include <OpenThreads/Thread>
#include <OpenThreads/Barrier>


class ChannelWorker : public osg::Referenced, public OpenThreads::Thread
{
public:
	ChannelWorker(int numThreads, OpenThreads::Barrier& syncBarrier) ;
	~ChannelWorker();
	virtual void run();
	virtual int cancel();
	
	void setDone(bool done);
	bool getDone() const { return _done; }

private:
	int _numThreads;
	bool _done;
	OpenThreads::Barrier& _syncBarrier;
};
